import { MoreHelpfulParser } from '..';
import { VagueHintParser } from '../vague-hint-parser/vague-hint-parser';
export function gcodeLinter(config) {
    function range(state, from = 0, to = state.doc.length) {
        const programText = state.sliceDoc(from, to).trimEnd();
        let parser;
        if (config.experimental) {
            parser = new MoreHelpfulParser();
        }
        else {
            parser = new VagueHintParser();
        }
        return parser.check(programText);
    }
    return (view) => {
        const found = [];
        const from = view.state.tree.topNode.from;
        const to = view.state.tree.topNode.to;
        for (const diagnostic of range(view.state, from, to)) {
            found.push(diagnostic);
        }
        return found;
    };
}
//# sourceMappingURL=gcode-linter.js.map